//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1  LimeGreen
#property indicator_color2  Red
#property indicator_color3  Gold
#property indicator_width1  2
#property indicator_width2  2
#property indicator_width3  2
#property indicator_minimum 0
#property indicator_maximum 1

//
//
//
//
//

extern string VmaParams = "12,50,0;13,50,0;14,50,0;15,50,0;16,50,0;17,50,0;18,50,0;19,50,0;";
extern string Dummy     = "";

//
//
//
//
//

double buffer0[];
double buffer1[];
double buffer2[];
double length1[];
double length2[];
double prices[];
int    size;

bool   calculateMacd;
string indicatorFileName;

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//

int init()
{
   SetIndexBuffer(0,buffer0); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,buffer1); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,buffer2); SetIndexStyle(2,DRAW_HISTOGRAM);

      //
      //
      //
      //
      //
      
      VmaParams = StringTrimLeft(StringTrimRight(VmaParams));
      if (StringSubstr(VmaParams,StringLen(VmaParams),1) != ";")
                       VmaParams = StringConcatenate(VmaParams,";");

         //
         //
         //
         //
         //                                   

         int n,m,s = 0;
         int i = StringFind(VmaParams,";",s);
         while (i > 0)
         {
            string current = StringSubstr(VmaParams,s,i-s);
            if (current!=";")
            {
               size = ArraySize(prices)+1;
                      ArrayResize(prices ,size);
                      ArrayResize(length1,size);
                      ArrayResize(length2,size);
                        n = StringFind(current,",",0); length1[size-1]  = StrToDouble(StringSubstr(current,0,n));   m = n+1; 
                        n = StringFind(current,",",m); length2[size-1]  = StrToDouble(StringSubstr(current,m,n-m)); m = n+1;
                                                       prices[size-1]   = StrToDouble(StringSubstr(current,m,StringLen(current)-m));
            }
            s = i + 1;
            i = StringFind(VmaParams,";",s);
         }
         calculateMacd    = (Dummy=="calculateMacd");
         indicatorFileName = WindowExpertName();
         
         //
         //
         //
         //
         //
         
   IndicatorShortName("Velocity macd summed "+size);
   return(0);
}
int deinit() { return (0); }

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit  = MathMin(Bars-counted_bars,Bars-1);
         if (calculateMacd)
         {
            for(int i=limit; i>=0; i--)
            {
               buffer1[i] = iVelocity(iMA(NULL,0,1,0,MODE_SMA,prices[0],i),length2[0],i,0)-iVelocity(iMA(NULL,0,1,0,MODE_SMA,prices[0],i),length1[0],i,1);
               buffer0[i] = buffer0[i+1];
                  if (buffer1[i]>0) buffer0[i] =  1;
                  if (buffer1[i]<0) buffer0[i] = -1;
            }
            return(0);               
         }         
         
   //
   //
   //
   //
   //

   for(i=limit; i>=0; i--)
   {
      int sum=0;
      for (int k=0; k<size; k++)
      {
         string params = DoubleToString(length1[k],0 )+","+
                         DoubleToString(length2[k],0 )+","+
                         DoubleToString(prices[k],0  )+";";
         sum += iCustom(NULL,0,indicatorFileName,params,"calculateMacd",0,i);
      }
      buffer0[i] = EMPTY_VALUE;
      buffer1[i] = EMPTY_VALUE;
      buffer2[i] = EMPTY_VALUE;
         if (sum== size) { buffer0[i] = 1; continue; }
         if (sum==-size) { buffer1[i] = 1; continue; }
                           buffer2[i] = 1;
   }     
   return(0);
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

double vprices[][2];
double iVelocity(double price, double length, int i,int instanceNo=0)
{
   if (ArrayRange(vprices,0)!=Bars) ArrayResize(vprices,Bars); i=Bars-i-1;
   
      vprices[i][instanceNo] = price;
      double suma = 0.0, sumwa=0;
      double sumb = 0.0, sumwb=0;

      for(int k=0; k<length; k++)
      {
         double weight = length-k;
            suma  += vprices[i-k][instanceNo] * weight;
            sumb  += vprices[i-k][instanceNo] * weight * weight;
            sumwa += weight;
            sumwb += weight*weight;
      }
   return(sumb/sumwb-suma/sumwa);
}